Nedaed = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDB-2.0", "AceConsole-2.0", "CandyBar-2.0")

local Gratuity = AceLibrary("Gratuity-2.0")
local CandyBar = AceLibrary("CandyBar-2.0")
local Dewdrop = AceLibrary("Dewdrop-2.0")
local SharedMedia = AceLibrary("SharedMedia-1.0")
local BabbleSpell = AceLibrary("Babble-Spell-2.2")
local L = AceLibrary("AceLocale-2.2"):new("Nedaed")

local yourkick = nil;
local started = nil
local stop = nil
local castingaspell = nil

local anchor = nil
local options = {
	type = "group",
	args = {
		anchor = {
			order = 1,
			type = "toggle",
			name = L["show_anchor"],
			desc = L["show_anchor_desc"],
			get = function() return anchor and anchor:IsShown() end,
			set = function(v) Nedaed:ToggleAnchor(v) end,
		},
		texture = {
			type = "text",
			name = L["texture"], 
			desc = L["texture_desc"],
			get = function () return Nedaed.db.profile.texture end,
			set = function (v) Nedaed.db.profile.texture = v
				for key, barId in ipairs(CandyBar.groups["Nedaed"].bars) do
					Nedaed:SetCandyBarTexture(barId, SharedMedia:Fetch("statusbar", Nedaed.db.profile.texture))
				end
			end,
			validate = SharedMedia:List("statusbar"),
		},
		nextone = {
			type = "text",
			name = L["next"],
			desc = L["next_desc"],
			get = function () return Nedaed.db.profile.nextone; end,
			set = function (v) Nedaed.db.profile.nextone = v; end,
			usage = "<name>"
		},
		startone = {
			type = "text",
			name = L["start"],
			desc = L["start_desc"],
			get = function () return Nedaed.db.profile.startone; end,
			set = function (v)
				Nedaed.db.profile.startone = v
				if(v == UnitName("player")) then 
					yourkick = true
				end
			end,
			usage = "<name>"
		},
		stopsending = {
			type = "toggle",
			name = L["stop"],
			desc = L["stop_desc"],
			get = function() return Nedaed.db.profile.stopsending; end,
    	set = "ToggleSending",
    	handler = Nedaed
			--get = function () Nedaed.db.profile.stopsending = true; end,
			--set = function () Nedaed.db.profile.stopsending = false; end,
		},
		scale = {
			type = "range",
			name = L["scale"],
			desc = L["scale_desc"],
			get = function() return Nedaed.db.profile.scale or 1.0; end,
    	set = function(s) Nedaed.db.profile.scale = s; end,
    	min = 0.1,
    	max = 2.0,
    	step = 0.05,
    	isPercent = true,
			--get = function () Nedaed.db.profile.stopsending = true; end,
			--set = function () Nedaed.db.profile.stopsending = false; end,
		},
	}
}


function Nedaed:ToggleSending()
	self.db.profile.stopsending = not self.db.profile.stopsending;
end
function Nedaed:OnInitialize()
	local defaults = {
		growth = true,
		texture = "default",
		x = nil,
		y = nil,
	}
	self:RegisterDB("NedaedDB")
	self:RegisterDefaults("profile", defaults)
	self:RegisterChatCommand("/Nedaed", {type = "execute", func = "ShowOptions"})
	Dewdrop:Register("Nedaed", "children", options, "cursorX", true, "cursorY", true)
	
	self:CreateAnchor()
	self:RegisterCandyBarGroup("Nedaed")
	self:SetCandyBarGroupPoint("Nedaed", "TOP", anchor, "BOTTOM", 0, 0)
	self:SetCandyBarGroupGrowth("Nedaed", self.db.profile.growth or true)
end

function Nedaed:OnEnable()
	self:RegisterEvent("UNIT_SPELLCAST_START")
	self:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE")
	self:RegisterEvent("CHAT_MSG_COMBAT_SELF_MISSES")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("CHAT_MSG_ADDON")
	self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("UNIT_SPELLCAST_STOP")
	if(not self.db.profile.startone) then
		DEFAULT_CHAT_FRAME:AddMessage(L["configure"]);
	end
end

function Nedaed:UNIT_SPELLCAST_STOP(unit)
	local spell, rank, displayName, icon, startTime, endTime = UnitCastingInfo(unit)
	if(spell == L["spiritshock"] or spell == L["spiritshock_de1"] or spell == L["spiritshock_de2"]) then
		self:StopCandyBar(self:GetBarId(spell))
		self:UnregisterCandyBar(self:GetBarId(spell))
		castingaspell = nil
	end
end
function Nedaed:CHAT_MSG_ADDON()
	if(arg1 == "NEDA" and string.lower(UnitName("player")) == string.lower(arg2)) then
		yourkick = true
	end
end
function Nedaed:PLAYER_REGEN_ENABLED()
	yourkick = nil
	started = nil
	if(self.db.profile.startone == UnitName("player")) then
		yourkick = true
	end
end
function Nedaed:UNIT_SPELLCAST_INTERRUPTED(unit)
	local spell, rank, displayName, icon, startTime, endTime = UnitCastingInfo(unit)
	if(spell == L["spiritshock"] or spell == L["spiritshock_de1"] or spell == L["spiritshock_de2"] or spell == "Greater Heal") then
		self:StopCandyBar(self:GetBarId(spell))
		self:UnregisterCandyBar(self:GetBarId(spell))
		castingaspell = nil
	end
end
function Nedaed:UNIT_SPELLCAST_SUCCEEDED()
	if(self.db.profile.stopsending) then return; end
	if((arg2 == L["spiritshock"] or arg2 == L["spiritshock_de1"] or arg2 == L["spiritshock_de2"])and yourkick) then
		SendChatMessage(L["failed"]..arg2, "RAID")
		SendChatMessage(string.upper(self.db.profile.nextone)..L["next_interrupt"], "WHISPER", nil, self.db.profile.nextone)
		SendAddonMessage("NEDA", self.db.profile.nextone, "WHISPER", self.db.profile.nextone)
		yourkick = nil
	end
end
function Nedaed:CHAT_MSG_SPELL_SELF_DAMAGE()
local v = "";
	if(self.db.profile.stopsending) then return; end
	if(string.find(arg1, BabbleSpell["Kick"])or string.find(arg1, BabbleSpell["Pummel"])) then
		if(not (string.find(string.lower(arg1), "hit") or string.find(string.lower(arg1), "crit"))) then
			if(not castingaspell) then v = L["wrong"]; end
			SendChatMessage(string.upper(self.db.profile.nextone)..L["interrupt_now"]..v, "WHISPER", nil, self.db.profile.nextone)
			SendAddonMessage("NEDA", self.db.profile.nextone, "WHISPER", self.db.profile.nextone)
			yourkick = nil
			return;
		end
		if(not castingaspell) then v = L["wrong"]; end
		SendChatMessage(string.upper(self.db.profile.nextone)..L["next_interrupt"]..v, "WHISPER", nil, self.db.profile.nextone)
		SendAddonMessage("NEDA", self.db.profile.nextone, "WHISPER", self.db.profile.nextone)
		yourkick = nil
		return;
	end
end
function Nedaed:CHAT_MSG_COMBAT_SELF_MISSES()
	
	if(self.db.profile.stopsending) then return; end
	if(string.find(arg1, BabbleSpell["Kick"])or string.find(arg1, BabbleSpell["Pummel"])) then
		
	end
end

function Nedaed:UNIT_SPELLCAST_START()
	local spell, rank, displayName, icon, startTime, endTime = UnitCastingInfo(arg1)
	if(spell == L["spiritshock"] or spell == L["spiritshock_de1"] or spell == L["spiritshock_de2"]) then
		local data = {}
		data.rank = rank
		data.icon = icon
		data.name = spell
		data.startTime = startTime
		data.endTime = endTime
		if(UnitName("player") == self.db.profile.startone) then
			if(not started) then
				yourkick = true
				started = true
			end
		end
		castingaspell = true
		Nedaed:StartBar(spell, data, (endTime-startTime)/1000)
	end
end


function Nedaed:StartBar(name, data, duration)
	local barId = self:GetBarId(name)
	
	self:RegisterCandyBar(barId, duration, data.name and data.name or name, data.icon, "Green", "Orange", "Red")
	self:SetCandyBarReversed(barId, true)
	self:SetCandyBarScale(barId, Nedaed.db.profile.scale or 1.0)
	self:RegisterCandyBarWithGroup(barId, "Nedaed")
	self:SetCandyBarTexture(barId, SharedMedia:Fetch("statusbar", self.db.profile.texture))
	self:SetCandyBarFade(barId, 1)
	self:SetCandyBarTimeLeft(barId, duration - (GetTime() - data.startTime))
	self:StartCandyBar(barId, true)
end

function Nedaed:GetBarId(name)
	return "Nedaed" .. name
end

function Nedaed:ShowOptions()
	Dewdrop:Open("Nedaed")
end

function Nedaed:CreateAnchor()
	anchor = CreateFrame("Button", "NedaedFrame", UIParent)
	anchor:Hide()
	anchor:SetWidth(200)
	anchor:SetHeight(16)
	anchor:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16})
	anchor:SetBackdropColor(0.3, 0.3, 0.3, 0.7)
	
	anchor:SetMovable(true)
	anchor:RegisterForDrag("LeftButton")
	anchor:RegisterForClicks("RightButtonUp")
	
	anchor:SetScript("OnClick", function (this) self:ShowOptions() end)
	anchor:SetScript("OnDragStart", function(this) this:StartMoving() end)
	anchor:SetScript("OnDragStop", function(this) 
		this:StopMovingOrSizing()
		self.db.profile.x = this:GetLeft()
		self.db.profile.y = this:GetTop()
-- 		self:SetCandyBarGroupPoint("Nedaed", "TOPLEFT", UIParent, "BOTTOMLEFT", self.db.profile.x, self.db.profile.y)
	end)
	
	anchor:SetFont(GameFontHighlightSmall:GetFont(), 10)
	anchor:SetText("Nedaed")
	
	if not self.db.profile.x then
		anchor:SetPoint("CENTER", UIParent, "CENTER", 0, -200)
	else
		anchor:ClearAllPoints()
		anchor:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", self.db.profile.x, self.db.profile.y)
	end
end

function Nedaed:ToggleAnchor(show)
	if show then
		Dewdrop:Close()
		anchor:Show()
	else
		anchor:Hide()
	end
end
